// C Source File
// Created 27/07/2003; 11:59:25

#include "mkcomplib.h"

/*===============================================================================================
== Komp decompression
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the handle of the decompressed datas
===============================================================================================*/
CompErr dkomp_hsym(HSym hsym_var_src, unsigned char * dest) {
  HANDLE h_var;
  unsigned char * data;
  unsigned short length;
  
  TREE * tree=NULL;
  unsigned short file_len;
  unsigned short nL;

  CompErr error;
  
  if (hsym_var_src.folder==H_NULL)
    return COMP_ERR_NO_SRC_VAR;

  h_var=DerefSym(hsym_var_src)->handle;
  data=HLock(h_var);
  if (data==NULL)
    return COMP_ERR_MEM;
  length=*(unsigned short *)data;

  error=study_dkomp(data+2,length,&tree,&file_len,&nL);
  
  if (error!=COMP_NO_ERR) {
    HeapUnlock(h_var);
    return error;
  }  
  
  error=mk_dkomp(data+2,dest,NULL,0,tree,nL,file_len);
  
  HeapUnlock(h_var);

  return error;
}

