// C Source File
// Created 27/07/2003; 12:03:24

#include "mkcomplib.h"

/*===============================================================================================
== Komp decompression of a variable in a temporary handle
=================================================================================================
== hsym_var_src : HSym structure of the var to compress
== error : pointer to return the error code
=================================================================================================
== return a handle with the compressed datas : the H_NULL handle if there is a error.
===============================================================================================*/

HSym dkomp_hsym_var(HSym hsym_var_src, const unsigned char * name_var_dest, CompErr * error) {
  HANDLE h_var;
  unsigned char * data;
  unsigned short length;
  
  TREE * tree=NULL;
  unsigned short file_len;
  unsigned short nL;

  HANDLE h;
  unsigned char * dest;
  
  if (hsym_var_src.folder==H_NULL) {
    *error=COMP_ERR_NO_SRC_VAR;
    return HS_NULL;
  }

  h_var=DerefSym(hsym_var_src)->handle;
  data=HLock(h_var);
  if (data==NULL) {
    *error=COMP_ERR_MEM;
    return HS_NULL;
  }
  length=*(unsigned short *)data;

  *error=study_dkomp(data+2,length,&tree,&file_len,&nL);
  
  if (*error!=COMP_NO_ERR) {
    HeapUnlock(h_var);
    return HS_NULL;
  }
  
  h=HeapAlloc(file_len+2);
  if (h==H_NULL) {
    free(tree);
    HeapUnlock(h_var);
    *error=COMP_ERR_MEM;
    return HS_NULL;
  }
  dest=HLock(h);
  
  *error=mk_dkomp(data+2,dest,NULL,0,tree,nL,file_len);

  HeapUnlock(h_var);

  if (*error!=COMP_NO_ERR) {
  	HeapFree(h);
    return HS_NULL;
  }
  
  HeapUnlock(h);  

  return mk_var(hsym_var_src,name_var_dest,h,error);

}
