// C Source File
// Created 14/04/2003; 20:59:00

#include "mkcomplib.h"

/*===============================================================================================
== Komp compresion
=================================================================================================
== data : data to compress
== length : length of data to compress
== type : filelib type of the data
== temp : boolean false if we create a TI-OS variable (add the "ZIP" tag)
                  true if it's temporary
== error : pointer to return the error code
=================================================================================================
== return the handle of the compressed datas
===============================================================================================*/
void comp_stat(unsigned char * dest, unsigned char type, unsigned short stat[], unsigned short nb1, unsigned short nb2, char mode) {

  unsigned short val;
  short i;

  *dest++=type;  //copie du type
  *dest++=mode;  //copie du mode d'tree...
  if (mode!=0) { //mode 1 ou 2
    for (i=0;i<256;i++) {
      val=stat[i] ;
      *dest++=val ;  //stockage du premier octet du nb de carct
      if (mode==2) //si plein de nb de plus de 256
        *dest++=val>>8;  //stockage du deuxime octet du nb de carct
    }
  } else {  //mode "mix"
    *dest++=nb2 ;  //on copie le nb de caract >256
    *dest++=nb1 ;  //on copie le nb de caract <256
    for (i=0;i<256;i++) {  //copie des grand nb
      if ((val=stat[i]) > 255) {  //c'est un gd nb
        *dest++=i ;  //code du caract
        *dest++=stat[i]>>8 ;  //copie de son nb
        *dest++=val ;           //suite de la copie
      }
    }
    for (i=0;i<256;i++) {  //copie des peu nbreux
      val=stat[i];
      if (val!=0 && val<256) {
        *dest++=i ;  //code
        *dest++=val ;  //copie
      }
    }
  }

}



/*===============================================================================================
== Komp compresion
=================================================================================================
== data : data to compress
== length : length of data to compress
== type : filelib type of the data
== temp : boolean false if we create a TI-OS variable (add the "ZIP" tag)
                  true if it's temporary
== error : pointer to return the error code
=================================================================================================
== return the handle of the compressed datas
===============================================================================================*/
CompErr study_komp(unsigned char * data, unsigned short length,
                   unsigned short * * stat, TREE * * tree, unsigned short * comp_len, short * offset, short * nb1, short * nb2, short * mode,
                   BOOL temp) {
  unsigned long bit_len;
  unsigned short i;
  unsigned short val;
  short nL;
  
  *stat=(unsigned short *)malloc(256*sizeof(unsigned short));
  if (*stat==NULL)
    return COMP_ERR_MEM;

  nL=mk_stat(*stat,data,length-1);

  if ((*tree=malloc(nL*sizeof(TREE)))==NULL) {
    free(*stat);
    return COMP_ERR_MEM;
  }

  mk_tree(*stat,*tree,nL);

  bit_len=eval_len(*tree,nL,*stat);
  *offset=bit_len%8;
  
  for(i=0;i<256;i++) {
    val=(*stat)[i] ;
    *nb1+=(val!=0 && val<256) ;  //nb de (caract dont le nb est <256 et non nul)
    *nb2+=(val>=256) ;  //nb de (caract dont le nb est >=256)
  }
  *mode=(( *nb2 != 0) ? 2 : 1 );  //mode=2 => y'en a  + de 256   -   mode=1 => tout - de 256
  if (*nb1+2*(*nb2) < 255*(*mode))   //est-il plus profitable de faire un mode "mix" ?
    *mode=0 ;  //oui

//  long2  => length des donnes compresse (en bit)
//  long2%8!=0   => un octet de plus si ca dpasse
//  1 + 255*(*stat2) + 1+255*mode+(mode==0)*(nbre1+2*nbre2+2)  : tableau de stat (length dpendant du mode)
  *comp_len=(4+256*(*mode)+(*mode==0)*(3*(*nb2)+2*(*nb1)+2)+(bit_len>>3)+(*offset!=0)+7*(!temp));

  if (*comp_len>=length) {
    free(*tree);
    free(*stat);
    return COMP_ERR_CANT_COMP;
  }

  return COMP_NO_ERR;

}

/*===============================================================================================
== Komp compresion
=================================================================================================
== data : data to compress
== length : length of data to compress
== type : filelib type of the data
== temp : boolean false if we create a TI-OS variable (add the "ZIP" tag)
                  true if it's temporary
== error : pointer to return the error code
=================================================================================================
== return the handle of the compressed datas
===============================================================================================*/
CompErr mk_komp(unsigned char * data, unsigned short length, unsigned char * dest,
                unsigned short * stat, TREE tree[], unsigned short comp_len, short offset, short nb1, short nb2, short mode,
                unsigned char type, BOOL temp) {
  unsigned char * dest_tag;
   
  *(unsigned short *)dest=comp_len;

  dest+=2;
  *(unsigned short *)dest=length;
  dest_tag=dest+comp_len-7*(!temp);

  if (write_comp(data,length-1,tree,dest_tag-1,offset)==0) {
    free(tree);
    free(stat);
    return COMP_ERR_MEM;
  }
  free(tree);

  dest+=2;
  comp_stat(dest,type,stat,nb1,nb2,mode);

  free(stat);

  if (!temp) {
    memcpy(dest_tag,"\0KOMP\0",6);
    *(dest_tag+6)=OTH_TAG;
  }

  return COMP_NO_ERR;
}


