// C Source File
// Created 27/07/2003; 12:01:58

#include "mkcomplib.h"

/*===============================================================================================
== Komp compression of datas in a variable
=================================================================================================
== data : pointer of the datas to compress
== length : length of the datas to compress
== name_var_dest : name of the variable where the compressed datas will be stored
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the hsym structure created, else HS_NULL
===============================================================================================*/
HSym komp_data_hsym(unsigned char * data, unsigned short length, const unsigned char * name_var, CompErr * error) {

  unsigned short * stat=NULL;
  TREE * tree=NULL;
  unsigned short comp_len;
  short offset;
  short nb1;
  short nb2;
  short mode;

  HANDLE h;
  unsigned char * dest;
 
  *error=study_komp(data,length,&stat,&tree,&comp_len,&offset,&nb1,&nb2,&mode,FALSE);
  if (*error!=COMP_NO_ERR)
    return HS_NULL;
  
  h=HeapAlloc(comp_len+2);
  if (h==H_NULL) {
    free(tree);
    free(stat);
    *error=COMP_ERR_MEM;
    return HS_NULL;
  }
  
  dest=HLock(h);
  
  *error=mk_komp(data,length,dest,stat,tree,comp_len,offset,nb1,nb2,mode,OTH_TAG,FALSE);

  if (*error!=COMP_NO_ERR) {
    HeapFree(h);
    return HS_NULL;
  }
  
  HeapUnlock(h);

  return mk_var(HS_NULL,name_var,h,error);
}

