// C Source File
// Created 14/04/2003; 20:59:00

#include "mkcomplib.h"

/*===============================================================================================
== Komp compresion
=================================================================================================
== data : data to compress
== length : length of data to compress
== type : filelib type of the data
== temp : boolean false if we create a TI-OS variable (add the "ZIP" tag)
                  true if it's temporary
== error : pointer to return the error code
=================================================================================================
== return the handle of the compressed datas
===============================================================================================*/
HANDLE komp_data_temp(unsigned char * data, unsigned short length, unsigned char type,
                     CompErr * error) {
  unsigned short * stat=NULL;
  TREE * tree=NULL;
  unsigned short comp_len;
  short offset;
  short nb1;
  short nb2;
  short mode;

  HANDLE h;
  unsigned char * dest;
 
  *error=study_komp(data,length,&stat,&tree,&comp_len,&offset,&nb1,&nb2,&mode,TRUE);
  if (*error!=COMP_NO_ERR)
    return H_NULL;
  
  h=HeapAlloc(comp_len+2);
  if (h==H_NULL) {
    free(tree);
    free(stat);
    *error=COMP_ERR_MEM;
    return H_NULL;
  }
  
  dest=HLock(h);
  
  *error=mk_komp(data,length,dest,stat,tree,comp_len,offset,nb1,nb2,mode,type,TRUE);

  if (*error!=COMP_NO_ERR) {
    HeapFree(h);
    return H_NULL;
  }
  
  HeapUnlock(h);
  return h;
}

