// C Source File
// Created 14/04/2003; 20:59:00

#include "mkcomplib.h"

/*===============================================================================================
== Komp compresion
=================================================================================================
== data : data to compress
== length : length of data to compress
== type : filelib type of the data
== temp : boolean false if we create a TI-OS variable (add the "ZIP" tag)
                  true if it's temporary
== error : pointer to return the error code
=================================================================================================
== return the handle of the compressed datas
===============================================================================================*/
CompErr komp_hsym(HSym hsym_var_src, unsigned char * dest) {
  HANDLE h_var;
  unsigned char * data;
  unsigned short length;
  short type;

  unsigned short * stat=NULL;
  TREE * tree=NULL;
  unsigned short comp_len;
  short offset;
  short nb1;
  short nb2;
  short mode;

  CompErr error;
  
  if (hsym_var_src.folder==H_NULL)
    return COMP_ERR_NO_SRC_VAR;
  
  h_var=DerefSym(hsym_var_src)->handle;
  data=HLock(h_var);
  if (data==NULL)
    return COMP_ERR_MEM;
  length=*(unsigned short *)data;

  type=data[length+1];

  error=study_komp(data+2,length,&stat,&tree,&comp_len,&offset,&nb1,&nb2,&mode,TRUE);
  if (error!=COMP_NO_ERR) {
    HeapUnlock(h_var);
    return error;
  }

  error=mk_komp(data+2,length,dest,stat,tree,comp_len,offset,nb1,nb2,mode,type,TRUE);

  HeapUnlock(h_var);
  return error;
}

