// C Source File
// Created 27/07/2003; 11:57:45

#include "mkcomplib.h"

/*===============================================================================================
== Ziplib decompression of datas in a variables
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== name_var_dest : name of the variable where the compressed datas will be stored
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the hsym structure created, else HS_NULL
===============================================================================================*/

HSym dzip_data_hsym(unsigned char * data, unsigned short length, const unsigned char * name_var_dest, const unsigned char * str_tag, unsigned char tag_length, CompErr * error) {

  TREE * tree=NULL;
  short nL;
  unsigned short file_len;
  short byte_offset;
  short bit_offset;

  HANDLE h;
  unsigned char * dest;
  
  if ( (*data>=15 && (str_tag==NULL || tag_length==0) ) || name_var_dest==NULL) {
    *error=COMP_ERR_WRONG_TYPE;
    return HS_NULL;  //il faut imprativement donner un type  la variable et un nom
  }
  if (*data<15 && (str_tag==NULL || tag_length==0) ) {
    str_tag=&(conv_type_filelib_TIOS[*data]);
    tag_length=1;
  }
  
  *error=study_dzip(data,length,&tree,&nL,&file_len,&byte_offset,&bit_offset);
  
  if (*error!=COMP_NO_ERR)
    return HS_NULL;

  h=HeapAlloc(file_len+2);
  if (h==H_NULL) {
    free(tree);
    *error=COMP_ERR_MEM;
    return HS_NULL;
  }
  dest=HLock(h);
  
  *error=mk_dzip(data,dest,str_tag,tag_length,tree,nL,file_len,byte_offset,bit_offset);

  if (*error!=COMP_NO_ERR) {
    HeapFree(h);
    return HS_NULL;
  }
  
  HeapUnlock(h);  
    
  return mk_var(HS_NULL,name_var_dest,h,error);
}

