// C Source File
// Created 27/07/2003; 11:54:55

#include "mkcomplib.h"

/*===============================================================================================
== Ziplib decompression
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the handle of the decompressed datas
===============================================================================================*/

HANDLE dzip_data_temp(unsigned char * data, unsigned short length, CompErr * error) {
  TREE * tree=NULL;
  short nL;
  unsigned short file_len;
  short byte_offset;
  short bit_offset;

  HANDLE h;
  unsigned char * dest;

  *error=study_dzip(data,length,&tree,&nL,&file_len,&byte_offset,&bit_offset);
  
  if (*error!=COMP_NO_ERR)
    return H_NULL;

  h=HeapAlloc(file_len+2);
  if (h==H_NULL) {
    free(tree);
    *error=COMP_ERR_MEM;
    return H_NULL;
  }
  dest=HLock(h);
  
  *error=mk_dzip(data,dest,NULL,0,tree,nL,file_len,byte_offset,bit_offset);

  if (*error!=COMP_NO_ERR) {
    HeapFree(h);
    return H_NULL;
  }
  
  HeapUnlock(h);
  
  return h;
}

