// C Source File
// Created 14/04/2003; 20:58:56

#include "mkcomplib.h"

/*===============================================================================================
== Compression of the tree for ziplib
=================================================================================================
== this function compress the tree : in fact, we "walk" along the tree on the right branch. We
put a 1 if meet a node and a 0 if we meet a caracter. and the caracter are stored in the order we
meet them.
=================================================================================================
== node : structure that represent the tree with only its nodes
== root : the position of the root in the node table
== dest_caract : where to write the caracter of the tree
== dest_tree : where to write the compress tree
== offset : bit offset of writing
===============================================================================================*/
void comp_tree(TREE tree[], unsigned char * dest_caract, unsigned char nL) {
  unsigned char right_br[256];  //branche  gauche  aller visiter plus tard
  unsigned char no_right_br=0;        //no de la dernire branche gauche  aller visiter
  unsigned char offset=0;
  unsigned char * dest_tree=dest_caract+nL;  //adresse du dbut de l'arbre et fin du tableau des caractres
  unsigned char no=nL-2;
  
  *dest_tree=0x01;  //I suppose there is one node
left:
  if ((offset++)==7){
    offset=0;
    ++dest_tree;
  }

  if (tree[no].node_left) { //a node at the left
    right_br[no_right_br++]=no;  //save the number of node to visit after
    *dest_tree|=(1<<offset);      //node => 1
//disp2("1")
    no=tree[no].left_branch;    //go on the left
    goto left;
  }
//disp2("0")
  *(dest_caract++)=tree[no].left_branch;  //caracter on the left

right:  //look on the right
  if ((offset++)==7) {
    offset=0;
    ++dest_tree;
  }
  if (tree[no].node_right) { //node on the right
    *dest_tree|=(1<<offset);
//disp2("1")
    no=tree[no].right_branch;
    goto left;  //go looking on the left
  }
//disp2("0")
  *(dest_caract++)=tree[no].right_branch;  //caractre  gauche

  if ((no_right_br--)==0)  //no more branch to visit on the left
    return;
  no=right_br[no_right_br];  //look this branch on the left

  goto right;
}

/*===============================================================================================
== Compression of the tree for ziplib
=================================================================================================
== this function compress the tree : in fact, we "walk" along the tree on the right branch. We
put a 1 if meet a node and a 0 if we meet a caracter. and the caracter are stored in the order we
meet them.
=================================================================================================
== node : structure that represent the tree with only its nodes
== root : the position of the root in the node table
== dest_caract : where to write the caracter of the tree
== dest_tree : where to write the compress tree
== offset : bit offset of writing
===============================================================================================*/
CompErr study_zip(unsigned char * data, unsigned short length,
                  TREE * * tree, short * nL, unsigned short * comp_len, short * offset,
                  BOOL temp) {

  unsigned long  bit_len;
  unsigned long  l;
  unsigned short * stat;

  stat=malloc(256*sizeof(short));
  if (stat==NULL)
    return COMP_ERR_MEM;

  *nL=mk_stat(stat,data,length);  //make the caracters stat

  *tree=malloc((*nL)*sizeof(TREE));
  if (tree==NULL) {
    free(stat);
    return COMP_ERR_MEM;
  }

  mk_tree(stat,*tree,*nL);  //make the huffmann tree

  bit_len=eval_len(*tree,*nL,stat);   //get the bit-length of the compressed datas
  free(stat);

  l=(((unsigned long)(*nL))<<1)-1+bit_len;
  *offset=l&0x07;  //number of bit that "overflow"
  l>>=3;  //get the length in byte
  *comp_len=2+10+*nL+l+(*offset!=0)+6*(!temp);   //total length = handle_header + zip_header + comp_tree + comp_data + zip_tag

  if (*comp_len>=length) {
    free(*tree);
    return COMP_ERR_CANT_COMP;
  }
  return COMP_NO_ERR;
}


/*===============================================================================================
== Ziplib compresion
=================================================================================================
== data : data to compress
== length : length of data to compress
== type : filelib type of the data
== temp : boolean false if we create a TI-OS variable (add the "ZIP" tag)
                  true if it's temporary
== error : pointer to return the error code
=================================================================================================
== return the handle of the compressed datas
===============================================================================================*/
CompErr mk_zip(unsigned char * data, unsigned short length, unsigned char * data_dest,
               TREE * tree, short nL, unsigned short comp_len, short offset, unsigned char type, BOOL temp) {

  unsigned char * dest_tag;
  
  memset(data_dest+14,0,2*nL);

  dest_tag=data_dest+comp_len+2-6*(!temp);

  if (write_comp(data,length,tree,dest_tag-1,offset)==0)
    return COMP_ERR_MEM;
  
  comp_tree(tree,data_dest+14,nL);

  free(tree);

  if (!temp)
    memcpy(dest_tag,"\0ZIP\0\xF8",6);

  *(unsigned short*)data_dest=comp_len;  //length of the zip
  data_dest+=2;
  *data_dest=type;  //put the type
  *(++data_dest)=0xFF;
  *(unsigned short *)(++data_dest)=1;  //nb of compressed file
  *(unsigned short *)(data_dest+=2)=nL;   //nLenght (nb of different caracters)
  *(unsigned short *)(data_dest+=2)=(((unsigned short)nL-1)>>2)+10+nL; //position of the beginning address
  *(unsigned short *)(data_dest+=2)=(((unsigned short)nL<<1)-1)&0x07;  //position of the beginning bit (offset)
  *(unsigned short *)(data_dest+=2)=length;  //length of the initial file

  return COMP_NO_ERR;
}

